<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>
  <title>DNSSD.ServiceBrowser</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <link rel="stylesheet" type="text/css" href="../common/doxygen.css" />
  <link rel="stylesheet" media="screen" type="text/css" title="KDE Colors" href="../common/kde.css" />
</head>
<body>
<div id="container">
<div id="header">
  <div id="header_top">
    <div>
      <div>
        <img alt ="" src="../common/top-kde.jpg"/>
        KDE 4.2 PyKDE API Reference
      </div>
    </div>
  </div>
  <div id="header_bottom">
    <div id="location">
      <ul>
        <li>KDE's Python API</li>
      </ul>
    </div>

    <div id="menu">
      <ul>
        <li><a href="../modules.html">Overview</a></li>
<li><a href="http://techbase.kde.org/Development/Languages/Python">PyKDE Home</a></li>
<li><a href="http://kde.org/family/">Sitemap</a></li>
<li><a href="http://kde.org/contact/">Contact Us</a></li>
</ul>
    </div>
  </div>
</div>

<div id="body_wrapper">
<div id="body">
<div id="right">
<div class="content">
<div id="main">
<div class="clearer">&nbsp;</div>

<h1>ServiceBrowser Class Reference</h1>
<code>from PyKDE4.dnssd import *</code>
<p>
Inherits: <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a><br />

Namespace: DNSSD<br />
<h2>Detailed Description</h2>

<p>\class ServiceBrowser servicebrowser.h DNSSD/ServiceBrowser
</p>
<p>
Most important class for applications that want to discover specific services on network.
Suppose that you need list of web servers running. Example:
</p>
<p>
<pre class="fragment">
DNSSD.ServiceBrowser* browser = new DNSSD.ServiceBrowser("_http._tcp");
connect(browser,SIGNAL(serviceAdded(RemoteService.Ptr)),this,SLOT(addService(RemoteService.Ptr)));
connect(browser,SIGNAL(serviceRemoved(RemoteService.Ptr)),this,SLOT(delService(RemoteService.Ptr)));
browser-&gt;startBrowse();
</pre>
</p>
<p>
In above example addService will be called for every web server already running or just appearing
on network and delService will be called when server is stopped. Because no domain was passed
to constructor, default domain will be searched.
</p>
<p>

<dl class="author" compact><dt><b>Author:</b></dt><dd> Jakub Stachowski </dd></dl>
Browsing for specific type of services or all available service types
</p>
<table border="0" cellpadding="0" cellspacing="0"><tr><td colspan="2"><br><h2>Enumerations</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="#obj189114028">State</a>&nbsp;</td><td class="memItemRight" valign="bottom">{&nbsp;Working, Stopped, Unsupported&nbsp;}</td></tr>
<tr><td colspan="2"><br><h2>Signals</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj193644140">finished</a> ()</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj196881644">serviceAdded</a> (DNSSD.RemoteService.Ptr a0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj196881452">serviceRemoved</a> (DNSSD.RemoteService.Ptr a0)</td></tr>
<tr><td colspan="2"><br><h2>Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj171097068">__init__</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> type, bool autoResolve=0, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> domain=QString(), <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> subtype=QString())</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj193644140">finished</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198556140">isAutoResolving</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj196881644">serviceAdded</a> (self, DNSSD.RemoteService.Ptr a0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj196881452">serviceRemoved</a> (self, DNSSD.RemoteService.Ptr a0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">[DNSSD::RemoteService::Ptr]&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj196903948">services</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj196903116">startBrowse</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj196878604">virtual_hook</a> (self, int a0, void a1)</td></tr>
<tr><td colspan="2"><br><h2>Static Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj196878796">getLocalHostName</a> ()</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">DNSSD.ServiceBrowser.State&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198556684">isAvailable</a> ()</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qhostaddress.html">QHostAddress</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj198556268">resolveHostName</a> (<a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> hostname)</td></tr>
</table>
<hr><h2>Method Documentation</h2><a class="anchor" name="obj171097068"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>type</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">bool&nbsp;</td>
<td class="paramname"><em>autoResolve=0</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>domain=QString()</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>subtype=QString()</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>ServiceBrowser constructor.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>type</em>&nbsp;</td><td> Service types to browse for (example: "_http._tcp").

<tr><td></td><td valign="top"><em>autoResolve</em>&nbsp;</td><td> - after disovering new service it will be resolved and then
reported with serviceAdded() signal. It raises network usage by resolving all services,
so use it only when necessary.

<tr><td></td><td valign="top"><em>domain</em>&nbsp;</td><td> Domain name. Can be left as null string to use default domain

<tr><td></td><td valign="top"><em>subtypes</em>&nbsp;</td><td> Set it to browse only for specific subtype
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj193644140"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> finished</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Emitted when all services has been reported. This signal can be used
by application that just want to get list of currently available services
(similar to directory listing) and do not care about dynamic adding/removing
services later. This signal can be emitted many time: for example if new host
has been connected to network and is announcing some services interesting to
this ServiceBrowser, they will be reported by several serviceAdded() signals and
whole batch will be concluded by finished().
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("finished()"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj196878796"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> getLocalHostName</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname">)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>This function simply returns the name of this machine's hostname as announced by mDNS protocol.
Usually it will be the same as calling QHostInfo.localHostName(), however it may be changed to something different
in avahi configuration file (if using Avahi backend).
<dl class="return" compact><dt><b>Returns:</b></dt><dd> A QString representing the hostname. Returns QString() if failed
</dd></dl> <dl class="since" compact><dt><b>Since:</b></dt><dd> 4.2
</dd></dl>
</p></div></div><a class="anchor" name="obj198556140"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool isAutoResolving</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Returns true if newly discovered services are resolved before being reported with serviceAdded()
<dl class="since" compact><dt><b>Since:</b></dt><dd> 4.1
</dd></dl>
</p></div></div><a class="anchor" name="obj198556684"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">DNSSD.ServiceBrowser.State isAvailable</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname">)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Checks availability of DNS-SD services (this also covers publishing).
</p>
<p>
If you use this function to report an error to the user, below is a suggestion
on how to word the errors:
</p>
<p>
<pre class="fragment">
switch(DNSSD.ServiceBrowser.isAvailable()) {	    
case DNSSD.ServiceBrowser.Working:
return "";
case DNSSD.ServiceBrowser.Stopped:
return i18n("&lt;p&gt;The Zeroconf daemon is not running. See the Service Discovery Handbook"
" for more information.&lt;br/&gt;"
"Other users will not see this system when browsing"
" the network via zeroconf, but normal access will still work.&lt;/p&gt;");
case DNSSD.ServiceBrowser.Unsupported:
return i18n("&lt;p&gt;Zeroconf support is not available in this version of KDE."
" See the Service Discovery Handbook for more information.&lt;br/&gt;"
"Other users will not see this system when browsing"
" the network via zeroconf, but normal access will still work.&lt;/p&gt;");
default:
return i18n("&lt;p&gt;Unknown error with Zeroconf.&lt;br/&gt;"
"Other users will not see this system when browsing"
" the network via zeroconf, but normal access will still work.&lt;/p&gt;");
}
</pre>
</p></div></div><a class="anchor" name="obj198556268"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qhostaddress.html">QHostAddress</a> resolveHostName</td>
<td>(</td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>hostname</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Resolved a hostname using mDNS into IP address.
</p>
<p>
This function is very rarely useful - properly configured system is able to resolve mDNS-based host name
using system resolver.
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>hostname</em>&nbsp;</td><td> The hostname to be resolved
</td></tr> </table></dl>
<p> <dl class="return" compact><dt><b>Returns:</b></dt><dd> A QHostAddress containing the IP address. QHostAddress() returned if failed
</dd></dl> <dl class="since" compact><dt><b>Since:</b></dt><dd> 4.2
</dd></dl>
</p></div></div><a class="anchor" name="obj196881644"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> serviceAdded</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">DNSSD.RemoteService.Ptr&nbsp;</td>
<td class="paramname"><em>a0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Emitted when new service is discovered (or resolved
if autoresolve is set
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("serviceAdded(Ptr)"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj196881452"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> serviceRemoved</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">DNSSD.RemoteService.Ptr&nbsp;</td>
<td class="paramname"><em>a0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Emitted when service is no longer announced. RemoteService object
is deleted from services list and destroyed immediately after this
signal returns.
</p><dl compact><dt><b>Signal syntax:</b></dt><dd><code>QObject.connect(source, SIGNAL("serviceRemoved(Ptr)"), target_slot)</code></dd></dl></div></div><a class="anchor" name="obj196903948"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">[DNSSD::RemoteService::Ptr] services</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Returns list of services
</p></div></div><a class="anchor" name="obj196903116"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> startBrowse</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Starts browsing for services.
To stop it just destroy the object.
</p></div></div><a class="anchor" name="obj196878604"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> virtual_hook</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">int&nbsp;</td>
<td class="paramname"><em>a0</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">void&nbsp;</td>
<td class="paramname"><em>a1</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><hr><h2>Enumeration Documentation</h2><a class="anchor" name="obj189114028"></a>
<div class="memitem">
<div class="memproto">
<table class="memname">
<tr><td class="memname">State</td>
</tr>
</table>
</div>
<div class="memdoc"><p>Availability of DNS-SD services.
<li> Working - available </li>
<li> Stopped - not available because mdnsd daemon is not running. This flag is currently unused </li>
<li> Unsupported - not available because KDE was compiled without DNS-SD support </li>
</p><dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0"><tr><td valign="top"><em>Working</em>&nbsp;</td><td><tr><td valign="top"><em>Stopped</em>&nbsp;</td><td><tr><td valign="top"><em>Unsupported</em>&nbsp;</td><td></table>
</dl>
</div></div><p>
</div>
</div>
</div>

<div id="left">

<div class="menu_box">
<div class="nav_list">
<ul>
<li><a href="../allclasses.html">Full Index</a></li>
</ul>
</div>

<a name="cp-menu" /><div class="menutitle"><div>
  <h2 id="cp-menu-project">Modules</h2>
</div></div>
<div class="nav_list">
<ul>
<li><a href="../akonadi/index.html">akonadi</a></li>
<li><a href="../dnssd/index.html">dnssd</a></li>
<li><a href="../kdecore/index.html">kdecore</a></li>
<li><a href="../kdeui/index.html">kdeui</a></li>
<li><a href="../khtml/index.html">khtml</a></li>
<li><a href="../kio/index.html">kio</a></li>
<li><a href="../knewstuff/index.html">knewstuff</a></li>
<li><a href="../kparts/index.html">kparts</a></li>
<li><a href="../kutils/index.html">kutils</a></li>
<li><a href="../nepomuk/index.html">nepomuk</a></li>
<li><a href="../phonon/index.html">phonon</a></li><li><a href="../plasma/index.html">plasma</a></li>
<li><a href="../solid/index.html">solid</a></li>
<li><a href="../soprano/index.html">soprano</a></li>
</ul></div></div>

</div>

</div>
  <div class="clearer"/>
</div>

<div id="end_body"></div>
</div>
<div id="footer"><div id="footer_text">
This documentation is maintained by <a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;simon&#64;simonzone&#46;com">Simon Edwards</a>.<br />
        KDE<sup>&#174;</sup> and <a href="../images/kde_gear_black.png">the K Desktop Environment<sup>&#174;</sup> logo</a> are registered trademarks of <a href="http://ev.kde.org/" title="Homepage of the KDE non-profit Organization">KDE e.V.</a> |
        <a href="http://www.kde.org/contact/impressum.php">Legal</a>
    </div></div>
</body>
</html>
